#include "../df_access_control_lists.h"
#include "../../DatafoxLibraryIV.h"

DF_API_EXTERN void DF_API_CALL DFCClearEntrance2ListBuffer( int connectionId, int number )
{
    ChannelBridge *pChannel = theApp.GetAEChannel(connectionId);
    // Wurde Channel-Objekt ermittelt.
    if (pChannel == NULL)
    {
        return;
    }

    pChannel->logBegin("%s\t%i\t%i", __func__, connectionId, number);

    // zulaessige Bereiche pruefen
    if (!(((number >= 0) && (number <= 7)) || (number == -1)) )
    {
        pChannel->logEnd("");
        return;
    }

    pChannel->ClearEntrance2ListBuffer(number);

    pChannel->logEnd("");
}

DF_API_EXTERN int DF_API_CALL DFCMakeEntrance2List( int connectionId, int number, int recordCount, int size, unsigned char *buffer, int *errorNumber )
{
    ChannelBridge *pChannel = theApp.GetAEChannel(connectionId);
    // Wurde Channel-Objekt ermittelt.
    if (pChannel == NULL)
    {
        if (errorNumber) *errorNumber = IV_ERROR_CHANNEL;
        return 0;
    }

    pChannel->logBegin("%s\t%i\t%i\t%i\t%i", __func__, connectionId, number, recordCount, size);

    // zulaessige Bereiche pruefen
    if (!((number >= 0) && (number <= 7)) ||
        (buffer == NULL) || (errorNumber == NULL) )
    {
        if (errorNumber) *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", IV_ERROR_FUNCTION_PARAMETER, 0);
        return 0;
    }
    *errorNumber = IV_ERROR_SUCCESS;

    // ListNum ist:
    // 0: Reader         (33 Byte)
    // 1: Identification (64 Byte)
    // 2: Location       (20 Byte)
    // 3: Time           (25 Byte)
    // 4: Holiday        (21 Byte)
    // 5: Events         (17 Byte)
    // 6: Action         (21 Byte)
    // 7: Action2        (39 Byte)

    // Bereich der gueltigen Nummer pruefen.
    switch ( number )
    {
    case 0:
        // Anzahl moeglicher Datensaetze
        if ((recordCount < 1) /*|| (iLineCount > (FLASH_SIZE_LIST / ENTRANCE2_RECORD_SIZE_0))*/)
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Berechnete Listengroesze pruefen
        if (size != (recordCount * ENTRANCE2_RECORD_SIZE_0))
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Zu grosze Listen abfangen
        /*		if ((iLineCount * ENTRANCE2_RECORD_SIZE_0) > FLASH_SIZE_LIST) {

        *piError = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *piError, 0);
        return 0;
        }
        */		
        break;

    case 1:
        if ((recordCount < 1) /*|| (iLineCount > (FLASH_SIZE_LIST / ENTRANCE2_RECORD_SIZE_1))*/)
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }

        if (size != (recordCount * ENTRANCE2_RECORD_SIZE_1))
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Zu grosze Listen abfangen
        /*		if ((iLineCount * ENTRANCE2_RECORD_SIZE_1) > FLASH_SIZE_LIST) {

        *piError = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *piError, 0);
        return 0;
        }
        */		
        break;

    case 2:
        if ((recordCount < 1) /*|| (iLineCount > (FLASH_SIZE_LIST / ENTRANCE2_RECORD_SIZE_2))*/)
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }

        if (size != (recordCount * ENTRANCE2_RECORD_SIZE_2))
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Zu grosze Listen abfangen
        /*		if ((iLineCount * ENTRANCE2_RECORD_SIZE_2) > FLASH_SIZE_LIST) {

        *piError = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *piError, 0);
        return 0;
        }
        */		
        break;

    case 3:
        if ((recordCount < 1) /*|| (iLineCount > (FLASH_SIZE_LIST / ENTRANCE2_RECORD_SIZE_3))*/)
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }

        if (size != (recordCount * ENTRANCE2_RECORD_SIZE_3))
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Zu grosze Listen abfangen
        /*		if ((iLineCount * ENTRANCE2_RECORD_SIZE_3) > FLASH_SIZE_LIST) {

        *piError = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *piError, 0);
        return 0;
        }
        */		
        break;

    case 4:
        // Anzahl moeglicher Datensaetze
        if ((recordCount < 1) /*|| (iLineCount > (FLASH_SIZE_LIST / ENTRANCE2_RECORD_SIZE_4))*/)
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Berechnete Listengroesze pruefen
        if (size != (recordCount * ENTRANCE2_RECORD_SIZE_4))
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Zu grosze Listen abfangen
        /*		if ((iLineCount * ENTRANCE2_RECORD_SIZE_4) > FLASH_SIZE_LIST) {

        *piError = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *piError, 0);
        return 0;
        }
        */		
        break;

    case 5:
        // Anzahl moeglicher Datensaetze
        if ((recordCount < 1) /*|| (iLineCount > (FLASH_SIZE_LIST / ENTRANCE2_RECORD_SIZE_5))*/)
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Berechnete Listengroesze pruefen
        if (size != (recordCount * ENTRANCE2_RECORD_SIZE_5))
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Zu grosze Listen abfangen
        /*		if ((iLineCount * ENTRANCE2_RECORD_SIZE_5) > FLASH_SIZE_LIST) {

        *piError = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *piError, 0);
        return 0;
        }
        */		
        break;

    case 6:
        // Anzahl moeglicher Datensaetze
        if ((recordCount < 1) /*|| (iLineCount > (FLASH_SIZE_LIST / ENTRANCE2_RECORD_SIZE_6))*/)
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Berechnete Listengroesze pruefen
        if (size != (recordCount * ENTRANCE2_RECORD_SIZE_6))
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Zu grosze Listen abfangen
        /*		if ((iLineCount * ENTRANCE2_RECORD_SIZE_6) > FLASH_SIZE_LIST) {

        *piError = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *piError, 0);
        return 0;
        }
        */		
        break;

    case 7:
        // Anzahl moeglicher Datensaetze
        if ((recordCount < 1) /*|| (iLineCount > (FLASH_SIZE_LIST / ENTRANCE2_RECORD_SIZE_7))*/)
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Berechnete Listengroesze pruefen
        if (size != (recordCount * ENTRANCE2_RECORD_SIZE_7))
        {
            *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
            pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
            return 0;
        }
        // Zu grosze Listen abfangen
        /*		if ((iLineCount * ENTRANCE2_RECORD_SIZE_7) > FLASH_SIZE_LIST) {

        *piError = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *piError, 0);
        return 0;
        }
        */		
        break;

    default:
        *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t\t%i\t(%i)", *errorNumber, 0);
        return 0;
    }

    int iRes = pChannel->MakeEntrance2List(number, recordCount, size, buffer);

    pChannel->logEnd("\t\t%i\t(%i)", IV_ERROR_SUCCESS, iRes);

    return iRes;
}

DF_API_EXTERN int DF_API_CALL DFCLoadEntrance2List( int connectionId, int deviceAddress, int number, int *errorNumber )
{
    ChannelBridge *pChannel = theApp.GetAEChannel(connectionId);
    // Wurde Channel-Objekt ermittelt.
    if (pChannel == NULL)
    {
        if (errorNumber) *errorNumber = IV_ERROR_CHANNEL;
        return 0;
    }

    pChannel->logBegin("%s\t%i\t%i\t%i", __func__, connectionId, deviceAddress, number);

    // zulaessige Bereiche pruefen
    if (!(((deviceAddress >= 1) && (deviceAddress <= 250)) || (deviceAddress == 254)) ||
        !(((number >= 0) && (number <= 7)) || (number == -1)) ||
        (errorNumber == NULL) )
    {
        if (errorNumber) *errorNumber = IV_ERROR_FUNCTION_PARAMETER;
        pChannel->logEnd("\t%i\t(%i)", IV_ERROR_FUNCTION_PARAMETER, 0);
        return 0;
    }
    *errorNumber = IV_ERROR_SUCCESS;

    // Schnittstelle geoeffnet?
    if (!pChannel->isOpen())
    {
        *errorNumber = IV_ERROR_CHANNEL_CLOSED;
        pChannel->logEnd("\t%i\t(%i)", *errorNumber, 0);
        return 0;
    }

    // Zutrittskontrolle Version 2 wird erst ab 04.01.xx unterstuetzt.
    unsigned char protocolVersion = pChannel->getProtocolVersion(deviceAddress);
    if (protocolVersion < 3)
    {
        *errorNumber = IV_ERROR_VERSION_FIRMWARE;
        pChannel->logEnd("\t%i\t(%i)", *errorNumber, 0);
        return 0;
    }

    int iRes;
    char version[32];
    memset(version, 0, sizeof(version));
    // Firmwareversion lesen
    if (!(iRes = pChannel->getVersionFirmware(deviceAddress, version, errorNumber)))
    {
        pChannel->logEnd("\t%i\t(%i)", *errorNumber, 0);
        return 0;
    }
    /*
    // Firmwareversion pruefen
    if (!theApp.m_util.CheckVersionFirmwareZK(version)) {

    *piError = IV_ERROR_FUNCTION_UNAVAILABLE;
    pChannel->logEnd("\t%i\t(%i)", *piError, 0);
    return 0;
    }
    */
    // Listendaten wegschreiben. BIN
    if (pChannel->logIsWriteList())
    {
        char fileNameBin[_MAX_PATH];
        char basePath[_MAX_PATH];
        int listNum;
        time_t t;
        tm *ltm;

        t = time(NULL);
        ltm = localtime(&t);

        for (listNum=0; listNum < 8; listNum++)
        {
            // Dateiname der Logdatei
            sprintf(fileNameBin, LOG_LIST_FILENAME_BIN, pChannel->logGetBasePath(basePath),
                ltm->tm_year % 100, ltm->tm_mon + 1, ltm->tm_mday,
                ltm->tm_hour, ltm->tm_min, ltm->tm_sec, connectionId, 'E', listNum);

            // Daten in Datei schreiben.
            pChannel->WriteListEntrance2ToBinFile(listNum, fileNameBin);
        }
    }

    // Listendaten wegschreiben. TXT
    if (pChannel->logIsWriteList() > 1)
    {
        char fileNameTxt[_MAX_PATH];
        char basePath[_MAX_PATH];
        unsigned char listName[32], fieldCount, varList;
        int listNum;
        time_t t;
        tm *ltm;

        t = time(NULL);
        ltm = localtime(&t);

        for (listNum=0; listNum < 8; listNum++)
        {
            if (!pChannel->GetTableRecord(200 + listNum, listName, &fieldCount, &varList, TRUE))
                break;

            // Dateiname der Logdatei
            sprintf(fileNameTxt, LOG_LIST_FILENAME_TXT, pChannel->logGetBasePath(basePath),
                ltm->tm_year % 100, ltm->tm_mon + 1, ltm->tm_mday,
                ltm->tm_hour, ltm->tm_min, ltm->tm_sec, connectionId, 'E', listName);

            // Daten in die Datei schreiben.
            pChannel->WriteListEntrance2ToTextFile(listNum, fileNameTxt);
        }
    }

    iRes = pChannel->writeEntrance2ListData(deviceAddress, number, errorNumber);
    // Nach Kommunikationsfehler, Kanal bereinigen
    if (iRes == 0) pChannel->resetWithError(*errorNumber);

    pChannel->logEnd("\t%i\t(%i)", *errorNumber, iRes);

    return iRes;
}
