#ifndef TCPIPINFO_H
#define TCPIPINFO_H

#include <memory.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#ifdef _MSC_VER
#include <winsock.h>
#else
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#endif

class tcpipInfo 
{
public:
    tcpipInfo() 
    {
        Reset();
    }

    void Reset()
    {
        length = sizeof(data);
        memset( data, 0, sizeof(data) );
        memset( ip, 0, sizeof(ip) );
        version = mac = NULL;
        port = 0;
    }

    void Parse()
    {
        // Werte aufschluesseln
        int num = 0;
        unsigned char b1, b2, b3, b4;
        char *token = strtok( data, "\r" );
        char *pIp = 0;
        while ( token != 0 )
        {
            num++;
            switch ( num )
            {
                case 1: 
                    version = token; 
                    break;

                case 2:	
                    pIp = token; 
                    break;

                case 3:	
                    port = atoi(token); 
                    break;

                case 4:	
                    mac = token; 
                    break;
            }

            token = strtok( NULL, "\r" );
        }

        // Die IP- und Portnummern werden mit Vornullen geliefert,
        // Diese sind zu entfernen.
        num = 0;
        b1 = b2 = b3 = b4 = 0;
        if ( pIp != NULL && strlen( pIp ) )
        {
            token = strtok( pIp, "." );
            while ( token != NULL )
            {
                num++;
                switch ( num )
                {
                    case 1: 
                        b1 = (unsigned char)atoi( token );
                        break;

                    case 2: 
                        b2 = (unsigned char)atoi( token );
                        break;

                    case 3: 
                        b3 = (unsigned char)atoi( token );
                        break;

                    case 4: 
                        b4 = (unsigned char)atoi( token );
                        break;
                }

                token = strtok( NULL, "." );
            }
        }

        // Ip ohne Vornullen
        sprintf( ip, "%i.%i.%i.%i", b1, b2, b3, b4 );

        // IP Pruefen
        if ( inet_addr( ip ) == INADDR_NONE )
        {
            // Ungueltige Adresse
            memset( ip, 0, sizeof(ip) );
        }
    }

public:
    char data[255];
    int length;
    char *version;
    char ip[16];
    int port;
    char *mac;
};

#endif
